//+------------------------------------------------------------------+
//| Copyright 2006, Open Source                                      |
//| http://www.finanzaonline.com                                     |
//| Done by:           |
//|                                |
//+------------------------------------------------------------------+


// da usare su grafici orari
//Modified by Spider4896~

#property copyright "Copyright 2006, Open Source"
#property link      " "

#define MAGIC 943448

extern double Lots = 1.0;
extern double lStopLoss = 70;
extern double sStopLoss = 60;
extern double lTakeProfit = 2000;
extern double sTakeProfit = 2000;
extern double Profit = 90;              //Total $ to close Profit per trade
extern double BLVL = 10;                //RSI Buy LVL
extern double SLVL = 90;                //RSI Sell LVL
extern double PERIOD = 2;               //RSI Period
extern int    startbuy       =  30;     // allows trading when longstoch gets below this level
extern int    startsell      =  70;     // allows trading when longstoch gets above this level
extern int    StochK         =  6;      // stochastic setting on "longterm" time frame
extern int    StochD         =  2;      // stochastic setting on "longterm" time frame
extern int    StochSlowing   =  2;      // stochastic setting on "longterm" time frame
extern int Slippage = 1;
extern color clOpenBuy = Blue;
extern color clCloseBuy = Aqua;
extern color clOpenSell = Red;
extern color clCloseSell = Violet;
extern color clModiBuy = Blue;
extern color clModiSell = Red;
extern bool UseSound = false;
extern bool   LotIncrease    =  false;
extern bool   OneEntryPerBar    = false;
extern string Name_Expert = "Magic RSI";
extern string NameFileSound = "alert.wav";

double StartingBalance = 0;

datetime
         CheckTime,
         CheckEntryTime,
         CrossTime;
         
static int TimeFrame            = 0;


int init()
  {
   if(LotIncrease)
     {
      StartingBalance=AccountBalance()/Lots;
     }
  }
  
//+----------------+
//| Custom DE-init |
//+----------------+  


int deinit()
  {
//---- 
   
//----------------------- PREVENT RE-COUNTING WHILE USER CHANGING TIME FRAME
//----------------------- SOURCE : CODERSGURU
   TimeFrame=Period(); 
   return(0);
}
//+------------------------------------------------------------------------+
//| cancels all pending orders and closes open positions                   |
//+------------------------------------------------------------------------+

void CloseAllThisSymbolBuy()
{
  int totalorders = OrdersTotal();
  double tradesinprofit;
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGIC)  // only look if mygrid and symbol...
      {
           //Close opened long positions
           if ( OrderType() == OP_BUY )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
      }
  }
  return; 
  }
   
//+------------------------------------------------------------------------+
//| cancels all pending orders and closes open positions                   |
//+------------------------------------------------------------------------+

void CloseAllThisSymbolSell()
{
  int totalorders = OrdersTotal();
  double tradesinprofit;
  for(int i=totalorders-1;i>=0;i--)
 {
    OrderSelect(i, SELECT_BY_POS);
    bool result = false;
    if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGIC)  // only look if mygrid and symbol...
      {
           //Close opened short positions
           if ( OrderType() == OP_SELL )  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
      }
  }
  return; 
  }
   
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
  double  i, OpenBuyLots, BuyOrders, OpenSellLots, SellOrders, BuySwap, SellSwap;
   double  TotalProfit, BuyProfit, SellProfit, TotalBuyProfit, TotalSellProfit;
     
   for(i = 0; i < OrdersTotal(); i++)
     {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGIC)
        {
         if (OrderType() == OP_BUY)
           {
            BuyProfit  +=  OrderProfit();
            BuySwap += OrderSwap();
           }
         if (OrderType() == OP_SELL)
           {
            SellProfit +=  OrderProfit();
            SellSwap += OrderSwap();
           }
        }
     }
   TotalBuyProfit = BuyProfit + BuySwap;
   TotalSellProfit = SellProfit + SellSwap;
   TotalProfit = BuyProfit + SellProfit;

  //---- close buy conditions 
    if(TotalBuyProfit >= Profit) CloseAllThisSymbolBuy(); 
    if(TotalSellProfit >= Profit) CloseAllThisSymbolSell();
    
    return;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start(){
   CheckForClose();
   if(OneEntryPerBar)
    {
     if(CheckEntryTime==iTime(NULL,TimeFrame,0)) return(0); else CheckEntryTime = iTime(NULL,TimeFrame,0);
    }
   
   if(LotIncrease)
     {
      Lots=NormalizeDouble(AccountFreeMargin()/StartingBalance,2);
     } 
   
   if(Bars<100){
      Print("bars less than 100");
      return(0);
   }
   if(lStopLoss<10){
      Print("StopLoss less than 10");
      return(0);
   }
   if(lTakeProfit<10){
      Print("TakeProfit less than 10");
      return(0);
   }
   if(sStopLoss<10){
      Print("StopLoss less than 10");
      return(0);
   }
   if(sTakeProfit<10){
      Print("TakeProfit less than 10");
      return(0);
   }

   double diRSI0=iRSI(NULL,60,PERIOD,PRICE_CLOSE,0);
   double diRSI1=iRSI(NULL,60,PERIOD,PRICE_CLOSE,0);
   double currentstoch  = iStochastic(NULL,60,StochK,StochD,StochSlowing,MODE_LWMA,0,MODE_SIGNAL,1);
   double previousstoch = iStochastic(NULL,60,StochK,StochD,StochSlowing,MODE_LWMA,0,MODE_SIGNAL,2);

   if(AccountFreeMargin()<(1000*Lots)){
      Print("We have no money. Free Margin = ", AccountFreeMargin());
      return(0);
   }
   if (!ExistPositions()){

      if(diRSI0<BLVL)   
      if(previousstoch<currentstoch && currentstoch < startbuy)   
        {
         OpenBuy();
         return(0);
      }

      if(diRSI1>SLVL)  
      if(previousstoch>currentstoch && currentstoch > startsell)   
        {
         OpenSell();
         return(0);
      }
   }
   return (0);
}



bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
				return(True);
			}
		} 
	} 
	return(false);
}


//void ModifyStopLoss(double ldStopLoss) { 
//   bool fm;
//   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE); 
//   if (fm && UseSound) PlaySound(NameFileSound); 
//} 

void OpenBuy() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
   ldStop = GetStopLossBuy(); 
   ldTake = GetTakeProfitBuy(); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_BUY,ldLot,Ask,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpenBuy); 
   if (UseSound) PlaySound(NameFileSound); 
} 
void OpenSell() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 

   ldLot = GetSizeLot(); 
   ldStop = GetStopLossSell(); 
   ldTake = GetTakeProfitSell(); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_SELL,ldLot,Bid,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpenSell); 
   if (UseSound) PlaySound(NameFileSound); 
} 
string GetCommentForOrder() { 	return(Name_Expert); } 
double GetSizeLot() { 	return(Lots); } 
double GetStopLossBuy() { 	return (Bid-lStopLoss*Point);} 
double GetStopLossSell() { 	return(Ask+sStopLoss*Point); } 
double GetTakeProfitBuy() { 	return(Ask+lTakeProfit*Point); } 
double GetTakeProfitSell() { 	return(Bid-sTakeProfit*Point); } 

